diff --git a/gcc/config/sh/sh.c b/gcc/config/sh/sh.c
index 6d909c7..795567b 100644
--- a/gcc/config/sh/sh.c
+++ b/gcc/config/sh/sh.c
@@ -716,7 +716,7 @@ got_mode_name:;
 	     "a multiple of 4 in the range 0-1020", ret.tcb_gbr_offset,
 	     ret.name);
 
-  if (ret.type == sh_atomic_model::soft_imask && TARGET_USERMODE)
+  if (ret.type == sh_atomic_model::soft_imask && GCC_OPTION (TARGET_USERMODE))
     err_ret ("cannot use atomic model %s in user mode", ret.name);
 
   return ret;
@@ -769,12 +769,12 @@ sh_option_override (void)
   int regno;
 
   SUBTARGET_OVERRIDE_OPTIONS;
-  if (optimize > 1 && !optimize_size)
-    target_flags |= MASK_SAVE_ALL_TARGET_REGS;
+  if (GCC_OPTION (optimize) > 1 && !GCC_OPTION (optimize_size))
+    GCC_OPTION (target_flags) |= MASK_SAVE_ALL_TARGET_REGS;
 
   /* Set default values of TARGET_CBRANCHDI4 and TARGET_CMPEQDI_T.  */
-  TARGET_CBRANCHDI4 = 1;
-  TARGET_CMPEQDI_T = 0;
+  GCC_OPTION (TARGET_CBRANCHDI4) = 1;
+  GCC_OPTION (TARGET_CMPEQDI_T) = 0;
 
   sh_cpu = PROCESSOR_SH1;
   assembler_dialect = 0;
@@ -801,15 +801,15 @@ sh_option_override (void)
   if (TARGET_SH5)
     {
       sh_cpu = PROCESSOR_SH5;
-      target_flags |= MASK_ALIGN_DOUBLE;
+      GCC_OPTION (target_flags) |= MASK_ALIGN_DOUBLE;
       if (TARGET_SHMEDIA_FPU)
-	target_flags |= MASK_FMOVD;
+	GCC_OPTION (target_flags) |= MASK_FMOVD;
       if (TARGET_SHMEDIA)
 	{
 	  /* There are no delay slots on SHmedia.  */
-	  flag_delayed_branch = 0;
+	  GCC_OPTION (flag_delayed_branch) = 0;
 	  /* Relaxation isn't yet supported for SHmedia */
-	  target_flags &= ~MASK_RELAX;
+	  GCC_OPTION (target_flags) &= ~MASK_RELAX;
 	  /* After reload, if conversion does little good but can cause
 	     ICEs:
 	     - find_if_block doesn't do anything for SH because we don't
@@ -824,35 +824,35 @@ sh_option_override (void)
 	     - find_if_case_2 doesn't do anything for the SHmedia after
 	       reload except when it can redirect a tablejump - and
 	       that's rather rare.  */
-	  flag_if_conversion2 = 0;
-	  if (! strcmp (sh_div_str, "call"))
+	  GCC_OPTION (flag_if_conversion2) = 0;
+	  if (! strcmp (GCC_OPTION (sh_div_str), "call"))
 	    sh_div_strategy = SH_DIV_CALL;
-	  else if (! strcmp (sh_div_str, "call2"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "call2"))
 	    sh_div_strategy = SH_DIV_CALL2;
-	  if (! strcmp (sh_div_str, "fp") && TARGET_FPU_ANY)
+	  if (! strcmp (GCC_OPTION (sh_div_str), "fp") && TARGET_FPU_ANY)
 	    sh_div_strategy = SH_DIV_FP;
-	  else if (! strcmp (sh_div_str, "inv"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv"))
 	    sh_div_strategy = SH_DIV_INV;
-	  else if (! strcmp (sh_div_str, "inv:minlat"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv:minlat"))
 	    sh_div_strategy = SH_DIV_INV_MINLAT;
-	  else if (! strcmp (sh_div_str, "inv20u"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv20u"))
 	    sh_div_strategy = SH_DIV_INV20U;
-	  else if (! strcmp (sh_div_str, "inv20l"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv20l"))
 	    sh_div_strategy = SH_DIV_INV20L;
-	  else if (! strcmp (sh_div_str, "inv:call2"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv:call2"))
 	    sh_div_strategy = SH_DIV_INV_CALL2;
-	  else if (! strcmp (sh_div_str, "inv:call"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv:call"))
 	    sh_div_strategy = SH_DIV_INV_CALL;
-	  else if (! strcmp (sh_div_str, "inv:fp"))
+	  else if (! strcmp (GCC_OPTION (sh_div_str), "inv:fp"))
 	    {
 	      if (TARGET_FPU_ANY)
 		sh_div_strategy = SH_DIV_INV_FP;
 	      else
 		sh_div_strategy = SH_DIV_INV;
 	    }
-	  TARGET_CBRANCHDI4 = 0;
+	  GCC_OPTION (TARGET_CBRANCHDI4) = 0;
 	  /* Assembler CFI isn't yet fully supported for SHmedia.  */
-	  flag_dwarf2_cfi_asm = 0;
+	  GCC_OPTION (flag_dwarf2_cfi_asm) = 0;
 	}
     }
   else
@@ -863,13 +863,13 @@ sh_option_override (void)
     }
   if (TARGET_SH1)
     {
-      if (! strcmp (sh_div_str, "call-div1"))
+      if (! strcmp (GCC_OPTION (sh_div_str), "call-div1"))
 	sh_div_strategy = SH_DIV_CALL_DIV1;
-      else if (! strcmp (sh_div_str, "call-fp")
+      else if (! strcmp (GCC_OPTION (sh_div_str), "call-fp")
 	       && (TARGET_FPU_DOUBLE || TARGET_FPU_SINGLE_ONLY
 		   || (TARGET_SHCOMPACT && TARGET_FPU_ANY)))
 	sh_div_strategy = SH_DIV_CALL_FP;
-      else if (! strcmp (sh_div_str, "call-table") && TARGET_DYNSHIFT)
+      else if (! strcmp (GCC_OPTION (sh_div_str), "call-table") && TARGET_DYNSHIFT)
 	sh_div_strategy = SH_DIV_CALL_TABLE;
       else
 	/* Pick one that makes most sense for the target in general.
@@ -893,31 +893,31 @@ sh_option_override (void)
 	  sh_div_strategy = SH_DIV_CALL_DIV1;
     }
   if (!TARGET_SH1)
-    TARGET_PRETEND_CMOVE = 0;
-  if (sh_divsi3_libfunc[0])
+    GCC_OPTION (TARGET_PRETEND_CMOVE) = 0;
+  if (GCC_OPTION (sh_divsi3_libfunc)[0])
     ; /* User supplied - leave it alone.  */
   else if (TARGET_DIVIDE_CALL_FP)
-    sh_divsi3_libfunc = "__sdivsi3_i4";
+    GCC_OPTION (sh_divsi3_libfunc) = "__sdivsi3_i4";
   else if (TARGET_DIVIDE_CALL_TABLE)
-    sh_divsi3_libfunc = "__sdivsi3_i4i";
+    GCC_OPTION (sh_divsi3_libfunc) = "__sdivsi3_i4i";
   else if (TARGET_SH5)
-    sh_divsi3_libfunc = "__sdivsi3_1";
+    GCC_OPTION (sh_divsi3_libfunc) = "__sdivsi3_1";
   else
-    sh_divsi3_libfunc = "__sdivsi3";
-  if (sh_branch_cost == -1)
+    GCC_OPTION (sh_divsi3_libfunc) = "__sdivsi3";
+  if (GCC_OPTION (sh_branch_cost) == -1)
     {
-      sh_branch_cost = 1;
+      GCC_OPTION (sh_branch_cost) = 1;
 
       /*  The SH1 does not have delay slots, hence we get a pipeline stall
 	  at every branch.  The SH4 is superscalar, so the single delay slot
 	  is not sufficient to keep both pipelines filled.  */
       if (! TARGET_SH2 || TARGET_HARD_SH4)
-	sh_branch_cost = 2;
+	GCC_OPTION (sh_branch_cost) = 2;
     }
 
   /* Set -mzdcbranch for SH4 / SH4A if not otherwise specified by the user.  */
   if (! global_options_set.x_TARGET_ZDCBRANCH && TARGET_HARD_SH4)
-    TARGET_ZDCBRANCH = 1;
+    GCC_OPTION (TARGET_ZDCBRANCH) = 1;
 
   for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
     if (! VALID_REGISTER_P (regno))
@@ -927,9 +927,9 @@ sh_option_override (void)
     if (! VALID_REGISTER_P (ADDREGNAMES_REGNO (regno)))
       sh_additional_register_names[regno][0] = '\0';
 
-  if ((flag_pic && ! TARGET_PREFERGOT)
+  if ((GCC_OPTION (flag_pic) && ! TARGET_PREFERGOT)
       || (TARGET_SHMEDIA && !TARGET_PT_FIXED))
-    flag_no_function_cse = 1;
+    GCC_OPTION (flag_no_function_cse) = 1;
 
   if (targetm.small_register_classes_for_mode_p (VOIDmode))
     {
@@ -940,58 +940,58 @@ sh_option_override (void)
 	 When sched1 is enabled, the ready queue will be reordered by
 	 the target hooks if pressure is high.  We can not do this for
 	 PIC, SH3 and lower as they give spill failures for R0.  */
-      if (!TARGET_HARD_SH4 || flag_pic)
-	flag_schedule_insns = 0;
+      if (!TARGET_HARD_SH4 || GCC_OPTION (flag_pic))
+	GCC_OPTION (flag_schedule_insns) = 0;
       /* ??? Current exception handling places basic block boundaries
 	 after call_insns.  It causes the high pressure on R0 and gives
 	 spill failures for R0 in reload.  See PR 22553 and the thread
 	 on gcc-patches
 	 <http://gcc.gnu.org/ml/gcc-patches/2005-10/msg00816.html>.  */
-      else if (flag_exceptions)
+      else if (GCC_OPTION (flag_exceptions))
 	{
-	  if (flag_schedule_insns && global_options_set.x_flag_schedule_insns)
+	  if (GCC_OPTION (flag_schedule_insns) && global_options_set.x_flag_schedule_insns)
 	    warning (0, "ignoring -fschedule-insns because of exception "
 			"handling bug");
-	  flag_schedule_insns = 0;
+	  GCC_OPTION (flag_schedule_insns) = 0;
 	}
-      else if (flag_schedule_insns
+      else if (GCC_OPTION (flag_schedule_insns)
 	       && !global_options_set.x_flag_schedule_insns)
-	flag_schedule_insns = 0;
+	GCC_OPTION (flag_schedule_insns) = 0;
     }
 
   /* Unwind info is not correct around the CFG unless either a frame
      pointer is present or M_A_O_A is set.  Fixing this requires rewriting
      unwind info generation to be aware of the CFG and propagating states
      around edges.  */
-  if ((flag_unwind_tables || flag_asynchronous_unwind_tables
-       || flag_exceptions || flag_non_call_exceptions)
-      && flag_omit_frame_pointer && !TARGET_ACCUMULATE_OUTGOING_ARGS)
+  if ((GCC_OPTION (flag_unwind_tables) || GCC_OPTION (flag_asynchronous_unwind_tables)
+       || GCC_OPTION (flag_exceptions) || GCC_OPTION (flag_non_call_exceptions))
+      && GCC_OPTION (flag_omit_frame_pointer) && !GCC_OPTION (TARGET_ACCUMULATE_OUTGOING_ARGS))
     {
       warning (0, "unwind tables currently require either a frame pointer "
 	       "or -maccumulate-outgoing-args for correctness");
-      TARGET_ACCUMULATE_OUTGOING_ARGS = 1;
+      GCC_OPTION (TARGET_ACCUMULATE_OUTGOING_ARGS) = 1;
     }
 
   /* Unwinding with -freorder-blocks-and-partition does not work on this
      architecture, because it requires far jumps to label crossing between
      hot/cold sections which are rejected on this architecture.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
 	{
 	  inform (input_location, 
 		  "-freorder-blocks-and-partition does not work with "
 		  "exceptions on this architecture");
-	  flag_reorder_blocks_and_partition = 0;
-	  flag_reorder_blocks = 1;
+	  GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
+	  GCC_OPTION (flag_reorder_blocks) = 1;
 	}
-      else if (flag_unwind_tables)
+      else if (GCC_OPTION (flag_unwind_tables))
 	{
 	  inform (input_location,
 		  "-freorder-blocks-and-partition does not support unwind "
 		  "info on this architecture");
-	  flag_reorder_blocks_and_partition = 0;
-	  flag_reorder_blocks = 1;
+	  GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
+	  GCC_OPTION (flag_reorder_blocks) = 1;
 	}
     }
 
@@ -1004,31 +1004,31 @@ sh_option_override (void)
       Aligning all jumps increases the code size, even if it might
       result in slightly faster code.  Thus, it is set to the smallest 
       alignment possible if not specified by the user.  */
-  if (align_loops == 0)
+  if (GCC_OPTION (align_loops) == 0)
     {
       if (TARGET_SH5)
-	align_loops = 8;
+	GCC_OPTION (align_loops) = 8;
       else
-	align_loops = optimize_size ? 2 : 4;
+	GCC_OPTION (align_loops) = GCC_OPTION (optimize_size) ? 2 : 4;
     }
 
-  if (align_jumps == 0)
+  if (GCC_OPTION (align_jumps) == 0)
     {
       if (TARGET_SHMEDIA)
-	align_jumps = 1 << CACHE_LOG;
+	GCC_OPTION (align_jumps) = 1 << CACHE_LOG;
       else
-	align_jumps = 2;
+	GCC_OPTION (align_jumps) = 2;
     }
-  else if (align_jumps < (TARGET_SHMEDIA ? 4 : 2))
-    align_jumps = TARGET_SHMEDIA ? 4 : 2;
+  else if (GCC_OPTION (align_jumps) < (TARGET_SHMEDIA ? 4 : 2))
+    GCC_OPTION (align_jumps) = TARGET_SHMEDIA ? 4 : 2;
 
-  if (align_functions == 0)
+  if (GCC_OPTION (align_functions) == 0)
     {
       if (TARGET_SHMEDIA)
-	align_functions = optimize_size
+	GCC_OPTION (align_functions) = GCC_OPTION (optimize_size)
 			  ? FUNCTION_BOUNDARY/8 : (1 << CACHE_LOG);
       else
-	align_functions = optimize_size ? 2 : 4;
+	GCC_OPTION (align_functions) = GCC_OPTION (optimize_size) ? 2 : 4;
     }
 
   /* The linker relaxation code breaks when a function contains
@@ -1036,48 +1036,48 @@ sh_option_override (void)
      compilation unit.  */
   if (TARGET_RELAX)
     {
-      int min_align = align_loops > align_jumps ? align_loops : align_jumps;
+      int min_align = GCC_OPTION (align_loops) > GCC_OPTION (align_jumps) ? GCC_OPTION (align_loops) : GCC_OPTION (align_jumps);
 
       /* Also take possible .long constants / mova tables into account.	*/
       if (min_align < 4)
 	min_align = 4;
-      if (align_functions < min_align)
-	align_functions = min_align;
+      if (GCC_OPTION (align_functions) < min_align)
+	GCC_OPTION (align_functions) = min_align;
     }
 
-  if (flag_unsafe_math_optimizations)
+  if (GCC_OPTION (flag_unsafe_math_optimizations))
     {
       /* Enable fsca insn for SH4A if not otherwise specified by the user.  */
       if (global_options_set.x_TARGET_FSCA == 0 && TARGET_SH4A_FP)
-	TARGET_FSCA = 1;
+	GCC_OPTION (TARGET_FSCA) = 1;
 
       /* Enable fsrra insn for SH4A if not otherwise specified by the user.  */
       if (global_options_set.x_TARGET_FSRRA == 0 && TARGET_SH4A_FP)
-	TARGET_FSRRA = 1;
+	GCC_OPTION (TARGET_FSRRA) = 1;
     }
 
   /*  Allow fsrra insn only if -funsafe-math-optimizations and
       -ffinite-math-only is enabled.  */
-  TARGET_FSRRA = TARGET_FSRRA
-		 && flag_unsafe_math_optimizations
-		 && flag_finite_math_only;
+  GCC_OPTION (TARGET_FSRRA) = GCC_OPTION (TARGET_FSRRA)
+		 && GCC_OPTION (flag_unsafe_math_optimizations)
+		 && GCC_OPTION (flag_finite_math_only);
 
   /* If the -mieee option was not explicitly set by the user, turn it on
      unless -ffinite-math-only was specified.  See also PR 33135.  */
   if (! global_options_set.x_TARGET_IEEE)
-    TARGET_IEEE = ! flag_finite_math_only;
+    GCC_OPTION (TARGET_IEEE) = ! GCC_OPTION (flag_finite_math_only);
 
-  if (sh_fixed_range_str)
-    sh_fix_range (sh_fixed_range_str);
+  if (GCC_OPTION (sh_fixed_range_str))
+    sh_fix_range (GCC_OPTION (sh_fixed_range_str));
 
   /* This target defaults to strict volatile bitfields.  */
-  if (flag_strict_volatile_bitfields < 0 && abi_version_at_least(2))
-    flag_strict_volatile_bitfields = 1;
+  if (GCC_OPTION (flag_strict_volatile_bitfields) < 0 && abi_version_at_least(2))
+    GCC_OPTION (flag_strict_volatile_bitfields) = 1;
 
   /* Parse atomic model option and make sure it is valid for the current
      target CPU.  */
   selected_atomic_model_
-    = parse_validate_atomic_model_option (sh_atomic_model_str);
+    = parse_validate_atomic_model_option (GCC_OPTION (sh_atomic_model_str));
 
   register_sh_passes ();
 }
@@ -1209,7 +1209,7 @@ sh_print_operand (FILE *stream, rtx x, int code)
 	break;
       }
     case '>':
-      if (flag_verbose_asm && JUMP_LABEL (current_output_insn))
+      if (GCC_OPTION (flag_verbose_asm) && JUMP_LABEL (current_output_insn))
 	{
 	  fputs ("\t! target: ", stream);
 	  output_addr_const (stream, JUMP_LABEL (current_output_insn));
@@ -1648,7 +1648,7 @@ void
 prepare_move_operands (rtx operands[], enum machine_mode mode)
 {
   if ((mode == SImode || mode == DImode)
-      && flag_pic
+      && GCC_OPTION (flag_pic)
       && ! ((mode == Pmode || mode == ptr_mode)
 	    && tls_symbolic_operand (operands[1], Pmode) != TLS_MODEL_NONE))
     {
@@ -1735,7 +1735,7 @@ prepare_move_operands (rtx operands[], enum machine_mode mode)
 	{
 	  rtx tga_op1, tga_ret, tmp, tmp2;
 
-	  if (! flag_pic
+	  if (! GCC_OPTION (flag_pic)
 	      && (tls_kind == TLS_MODEL_GLOBAL_DYNAMIC
 		  || tls_kind == TLS_MODEL_LOCAL_DYNAMIC
 		  || tls_kind == TLS_MODEL_INITIAL_EXEC))
@@ -1743,11 +1743,11 @@ prepare_move_operands (rtx operands[], enum machine_mode mode)
 	      /* Don't schedule insns for getting GOT address when
 		 the first scheduling is enabled, to avoid spill
 		 failures for R0.  */
-	      if (flag_schedule_insns)
+	      if (GCC_OPTION (flag_schedule_insns))
 		emit_insn (gen_blockage ());
 	      emit_insn (gen_GOTaddr2picreg ());
 	      emit_use (gen_rtx_REG (SImode, PIC_REG));
-	      if (flag_schedule_insns)
+	      if (GCC_OPTION (flag_schedule_insns))
 		emit_insn (gen_blockage ());
 	}
 
@@ -2046,7 +2046,7 @@ expand_cbranchdi4 (rtx *operands, enum rtx_code comparison)
        but saves us mispredicts because only one branch needs prediction.
        It also enables generating the cmpeqdi_t-1 pattern.  */
     case EQ:
-      if (TARGET_CMPEQDI_T)
+      if (GCC_OPTION (TARGET_CMPEQDI_T))
 	{
 	  emit_insn (gen_cmpeqdi_t (operands[1], operands[2]));
 	  emit_jump_insn (gen_branch_true (operands[3]));
@@ -2073,7 +2073,7 @@ expand_cbranchdi4 (rtx *operands, enum rtx_code comparison)
 	}
       break;
     case NE:
-      if (TARGET_CMPEQDI_T)
+      if (GCC_OPTION (TARGET_CMPEQDI_T))
 	{
 	  emit_insn (gen_cmpeqdi_t (operands[1], operands[2]));
 	  emit_jump_insn (gen_branch_false (operands[3]));
@@ -2398,8 +2398,8 @@ sh_emit_compare_and_branch (rtx *operands, enum machine_mode mode)
   if (GET_MODE_CLASS (mode) == MODE_FLOAT)
     {
       if (code == LT
-	  || (code == LE && TARGET_IEEE && TARGET_SH2E)
-	  || (code == GE && !(TARGET_IEEE && TARGET_SH2E)))
+	  || (code == LE && GCC_OPTION (TARGET_IEEE) && TARGET_SH2E)
+	  || (code == GE && !(GCC_OPTION (TARGET_IEEE) && TARGET_SH2E)))
 	{
 	  tem = op0, op0 = op1, op1 = tem;
 	  code = swap_condition (code);
@@ -2408,7 +2408,7 @@ sh_emit_compare_and_branch (rtx *operands, enum machine_mode mode)
       /* GE becomes fcmp/gt+fcmp/eq, for SH2E and TARGET_IEEE only.  */
       if (code == GE)
 	{
-	  gcc_assert (TARGET_IEEE && TARGET_SH2E);
+	  gcc_assert (GCC_OPTION (TARGET_IEEE) && TARGET_SH2E);
 	  need_ccmpeq = true;
 	  code = GT;
 	}
@@ -2479,7 +2479,7 @@ sh_emit_compare_and_set (rtx *operands, enum machine_mode mode)
 	}
       if (code == GE)
 	{
-	  if (TARGET_IEEE)
+	  if (GCC_OPTION (TARGET_IEEE))
 	    {
 	      lab = gen_label_rtx ();
 	      sh_emit_scc_to_t (EQ, op0, op1);
@@ -2606,7 +2606,7 @@ output_movedouble (rtx insn ATTRIBUTE_UNUSED, rtx operands[],
 static void
 print_slot (rtx insn)
 {
-  final_scan_insn (XVECEXP (insn, 0, 1), asm_out_file, optimize, 1, NULL);
+  final_scan_insn (XVECEXP (insn, 0, 1), asm_out_file, GCC_OPTION (optimize), 1, NULL);
 
   INSN_DELETED_P (XVECEXP (insn, 0, 1)) = 1;
 }
@@ -2634,7 +2634,7 @@ output_far_jump (rtx insn, rtx op)
   else
     {
       far = 1;
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  if (TARGET_SH2)
 	    jump =     "mov.l	%O0,%1" "\n"
@@ -2656,7 +2656,7 @@ output_far_jump (rtx insn, rtx op)
       && INSN_CODE (prev) == CODE_FOR_indirect_jump_scratch)
     {
       this_jmp.reg = SET_DEST (XVECEXP (PATTERN (prev), 0, 0));
-      if (REGNO (this_jmp.reg) == R0_REG && flag_pic && ! TARGET_SH2)
+      if (REGNO (this_jmp.reg) == R0_REG && GCC_OPTION (flag_pic) && ! TARGET_SH2)
 	jump =         "mov.l	r1,@-r15"	"\n"
 	       "	mova	%O0,r0"		"\n"
 	       "	mov.l	@r0,r1"		"\n"
@@ -2690,7 +2690,7 @@ output_far_jump (rtx insn, rtx op)
       else
 	output_asm_insn ("mov.l	@r15+,r13", 0);
     }
-  if (far && flag_pic && TARGET_SH2)
+  if (far && GCC_OPTION (flag_pic) && TARGET_SH2)
     {
       braf_base_lab = gen_label_rtx ();
       (*targetm.asm_out.internal_label) (asm_out_file, "L",
@@ -2700,7 +2700,7 @@ output_far_jump (rtx insn, rtx op)
     output_asm_insn (".align	2", 0);
   (*targetm.asm_out.internal_label) (asm_out_file, "L", CODE_LABEL_NUMBER (this_jmp.lab));
   this_jmp.op = op;
-  if (far && flag_pic)
+  if (far && GCC_OPTION (flag_pic))
     {
       if (TARGET_SH2)
 	this_jmp.lab = braf_base_lab;
@@ -2915,7 +2915,7 @@ sh_cannot_copy_insn_p (rtx insn)
 {
   rtx pat;
 
-  if (!reload_completed || !flag_pic)
+  if (!reload_completed || !GCC_OPTION (flag_pic))
     return false;
 
   if (!NONJUMP_INSN_P (insn))
@@ -3160,7 +3160,7 @@ and_xor_ior_costs (rtx x, int code)
 	  || satisfies_constraint_J16 (XEXP (x, 1)))
 	return 1;
       else
-	return 1 + rtx_cost (XEXP (x, 1), AND, 1, !optimize_size);
+	return 1 + rtx_cost (XEXP (x, 1), AND, 1, !GCC_OPTION (optimize_size));
     }
 
   /* These constants are single cycle extu.[bw] instructions.  */
@@ -3259,8 +3259,8 @@ addsubcosts (rtx x)
 static inline int
 multcosts (rtx x ATTRIBUTE_UNUSED)
 {
-  if (sh_multcost >= 0)
-    return sh_multcost;
+  if (GCC_OPTION (sh_multcost) >= 0)
+    return GCC_OPTION (sh_multcost);
   if (TARGET_SHMEDIA)
     /* ??? We have a mul insn, but it has a latency of three, and doesn't
        accept constants.  Ideally, we would use a cost of one or two and
@@ -3269,21 +3269,21 @@ multcosts (rtx x ATTRIBUTE_UNUSED)
        Using a multiply first and splitting it later if it's a loss
        doesn't work because of different sign / zero extension semantics
        of multiplies vs. shifts.  */
-    return optimize_size ? 2 : 3;
+    return GCC_OPTION (optimize_size) ? 2 : 3;
 
   if (TARGET_SH2)
     {
       /* We have a mul insn, so we can never take more than the mul and the
 	 read of the mac reg, but count more because of the latency and extra
 	 reg usage.  */
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
 	return 2;
       return 3;
     }
 
   /* If we're aiming at small code, then just count the number of
      insns in a multiply call sequence.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return 5;
 
   /* Otherwise count all the insns in the routine we'd be calling too.  */
@@ -4897,7 +4897,7 @@ static void
 fixup_mova (rtx mova)
 {
   PUT_MODE (XEXP (MOVA_LABELREF (mova), 0), QImode);
-  if (! flag_pic)
+  if (! GCC_OPTION (flag_pic))
     {
       SET_SRC (PATTERN (mova)) = MOVA_LABELREF (mova);
       INSN_CODE (mova) = -1;
@@ -4943,7 +4943,7 @@ untangle_mova (int *num_mova, rtx *first_mova, rtx new_mova)
   int n_addr = 0; /* Initialization to shut up spurious warning.  */
   int f_target, n_target = 0; /* Likewise.  */
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       /* If NEW_MOVA has no address yet, it will be handled later.  */
       if (INSN_ADDRESSES_SIZE() <= (unsigned) INSN_UID (new_mova))
@@ -4964,7 +4964,7 @@ untangle_mova (int *num_mova, rtx *first_mova, rtx new_mova)
       *first_mova = new_mova;
       return 2;
     }
-  if (!optimize
+  if (!GCC_OPTION (optimize)
       || ((f_target
 	   = INSN_ADDRESSES (INSN_UID (XEXP (MOVA_LABELREF (*first_mova), 0))))
 	  >= n_target))
@@ -5038,7 +5038,7 @@ find_barrier (int num_mova, rtx mova, rtx from)
       if (LABEL_P (from)
 	  && CODE_LABEL_NUMBER (from) <= max_labelno_before_reorg)
 	{
-	  if (optimize)
+	  if (GCC_OPTION (optimize))
 	    new_align = 1 << label_to_alignment (from);
 	  else if (BARRIER_P (prev_nonnote_insn (from)))
 	    new_align = 1 << barrier_align (from);
@@ -5149,7 +5149,7 @@ find_barrier (int num_mova, rtx mova, rtx from)
 	  switch (untangle_mova (&num_mova, &mova, from))
 	    {
 	      case 1:
-		if (flag_pic)
+		if (GCC_OPTION (flag_pic))
 		  {
 		    rtx src = SET_SRC (PATTERN (from));
 		    if (GET_CODE (src) == CONST
@@ -5200,7 +5200,7 @@ find_barrier (int num_mova, rtx mova, rtx from)
       /* For the SH1, we generate alignments even after jumps-around-jumps.  */
       else if (JUMP_P (from)
 	       && ! TARGET_SH2
-	       && ! optimize_size)
+	       && ! GCC_OPTION (optimize_size))
 	new_align = 4;
 
       /* There is a possibility that a bf is transformed into a bf/s by the
@@ -5290,7 +5290,7 @@ find_barrier (int num_mova, rtx mova, rtx from)
 
       /* Don't insert the constant pool table at the position which
 	 may be the landing pad.  */
-      if (flag_exceptions
+      if (GCC_OPTION (flag_exceptions)
 	  && CALL_P (from)
 	  && find_reg_note (from, REG_EH_REGION, NULL_RTX))
 	from = PREV_INSN (from);
@@ -5558,7 +5558,7 @@ gen_block_redirect (rtx jump, int addr, int need_block)
      when not optimizing.  */
   dest = XEXP (SET_SRC (PATTERN (jump)), 0);
   /* If the branch is out of range, try to find a scratch register for it.  */
-  if (optimize
+  if (GCC_OPTION (optimize)
       && (INSN_ADDRESSES (INSN_UID (dest)) - addr + (unsigned) 4092
 	  > 4092 + 4098))
     {
@@ -5566,7 +5566,7 @@ gen_block_redirect (rtx jump, int addr, int need_block)
       /* Don't look for the stack pointer as a scratch register,
 	 it would cause trouble if an interrupt occurred.  */
       unsigned attempt = 0x7fff, used;
-      int jump_left = flag_expensive_optimizations + 1;
+      int jump_left = GCC_OPTION (flag_expensive_optimizations) + 1;
 
       /* It is likely that the most recent eligible instruction is wanted for
 	 the delay slot.  Therefore, find out which registers it uses, and
@@ -5627,7 +5627,7 @@ gen_block_redirect (rtx jump, int addr, int need_block)
      Don't check if we are called recursively; the jump has been or will be
      checked in a different invocation then.  */
 
-  else if (optimize && need_block >= 0)
+  else if (GCC_OPTION (optimize) && need_block >= 0)
     {
       rtx next = next_active_insn (next_active_insn (dest));
       if (next && JUMP_P (next)
@@ -5717,7 +5717,7 @@ gen_far_branch (struct far_branch *bp)
      But don't do this when not optimizing, since we wouldn't suppress the
      alignment for the barrier then, and could end up with out-of-range
      pc-relative loads.  */
-  if (optimize)
+  if (GCC_OPTION (optimize))
     emit_barrier_after (jump);
   emit_label_after (bp->near_label, insn);
 
@@ -5816,7 +5816,7 @@ barrier_align (rtx barrier_or_label)
       pat = PATTERN (PREV_INSN (barrier_or_label));
       /* If this is a very small table, we want to keep the alignment after
 	 the table to the minimum for proper code alignment.  */
-      return ((optimize_size
+      return ((GCC_OPTION (optimize_size)
 	       || ((unsigned) XVECLEN (pat, 1) * GET_MODE_SIZE (GET_MODE (pat))
 		   <= (unsigned) 1 << (CACHE_LOG - 2)))
 	      ? 1 << TARGET_SHMEDIA : align_jumps_log);
@@ -5833,10 +5833,10 @@ barrier_align (rtx barrier_or_label)
     /* This is a barrier in front of a constant table.  */
     return 0;
 
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return 0;
 
-  if (! TARGET_SH2 || ! optimize)
+  if (! TARGET_SH2 || ! GCC_OPTION (optimize))
     return align_jumps_log;
 
   /* When fixing up pcloads, a constant table might be inserted just before
@@ -5929,7 +5929,7 @@ sh_loop_align (rtx label)
 {
   rtx next = label;
 
-  if (! optimize || optimize_size)
+  if (! GCC_OPTION (optimize) || GCC_OPTION (optimize_size))
     return 0;
 
   do
@@ -5960,7 +5960,7 @@ sh_reorg (void)
   /* We must split call insns before introducing `mova's.  If we're
      optimizing, they'll have already been split.  Otherwise, make
      sure we don't split them too late.  */
-  if (! optimize)
+  if (! GCC_OPTION (optimize))
     split_all_insns_noflow ();
 
   if (TARGET_SHMEDIA)
@@ -6171,7 +6171,7 @@ sh_reorg (void)
   if (TARGET_SH2)
     fixup_addr_diff_vecs (first);
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       mdep_reorg_phase = SH_SHORTEN_BRANCHES0;
       shorten_branches (first);
@@ -6384,7 +6384,7 @@ sh_reorg (void)
      also has an effect on the register that holds the address of the sfunc.
      Insert an extra dummy insn in front of each sfunc that pretends to
      use this register.  */
-  if (flag_delayed_branch)
+  if (GCC_OPTION (flag_delayed_branch))
     {
       for (insn = first; insn; insn = NEXT_INSN (insn))
 	{
@@ -6480,7 +6480,7 @@ split_branches (rtx first)
 		   proceeds to delete unreferenced code, and then if not
 		   optimizing, to un-delete the deleted instructions, thus
 		   leaving labels with too low uses counts.  */
-		if (! optimize)
+		if (! GCC_OPTION (optimize))
 		  {
 		    JUMP_LABEL (insn) = olabel;
 		    LABEL_NUSES (olabel)++;
@@ -6588,7 +6588,7 @@ split_branches (rtx first)
 		    if (! NEXT_INSN (far_label))
 		      continue;
 
-		    if (! optimize)
+		    if (! GCC_OPTION (optimize))
 		      {
 			JUMP_LABEL (insn) = far_label;
 			LABEL_NUSES (far_label)++;
@@ -6634,7 +6634,7 @@ split_branches (rtx first)
       if (far_branch_list->near_label
 	  && ! NEXT_INSN (far_branch_list->near_label))
 	gen_far_branch (far_branch_list);
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  && far_branch_list->far_label
 	  && ! --LABEL_NUSES (far_branch_list->far_label))
 	delete_insn (far_branch_list->far_label);
@@ -6660,7 +6660,7 @@ void
 final_prescan_insn (rtx insn, rtx *opvec ATTRIBUTE_UNUSED,
 		    int noperands ATTRIBUTE_UNUSED)
 {
-  if (TARGET_DUMPISIZE)
+  if (GCC_OPTION (TARGET_DUMPISIZE))
     fprintf (asm_out_file, "\n! at %04x\n", INSN_ADDRESSES (INSN_UID (insn)));
 
   if (TARGET_RELAX)
@@ -7105,7 +7105,7 @@ static int
 shmedia_reserve_space_for_target_registers_p (int regs_saved,
 					      HARD_REG_SET *live_regs_mask)
 {
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return 0;
   return shmedia_target_regs_stack_space (live_regs_mask) <= regs_saved;
 }
@@ -7147,7 +7147,7 @@ calc_live_regs (HARD_REG_SET *live_regs_mask)
   CLEAR_HARD_REG_SET (*live_regs_mask);
   if ((TARGET_SH4 || TARGET_SH2A_DOUBLE) && TARGET_FMOVD && interrupt_handler
       && df_regs_ever_live_p (FPSCR_REG))
-    target_flags &= ~MASK_FPU_SINGLE;
+    GCC_OPTION (target_flags) &= ~MASK_FPU_SINGLE;
   /* If we can save a lot of saves by switching to double mode, do that.  */
   else if ((TARGET_SH4 || TARGET_SH2A_DOUBLE) && TARGET_FMOVD
 	   && TARGET_FPU_SINGLE)
@@ -7157,7 +7157,7 @@ calc_live_regs (HARD_REG_SET *live_regs_mask)
 	      || interrupt_handler)
 	  && ++count > 2)
 	{
-	  target_flags &= ~MASK_FPU_SINGLE;
+	  GCC_OPTION (target_flags) &= ~MASK_FPU_SINGLE;
 	  break;
 	}
   /* PR_MEDIA_REG is a general purpose register, thus global_alloc already
@@ -7209,7 +7209,7 @@ calc_live_regs (HARD_REG_SET *live_regs_mask)
 	     && (reg != FPSCR_REG || TARGET_FPU_ANY))
 	  : (/* Only push those regs which are used and need to be saved.  */
 	     (TARGET_SHCOMPACT
-	      && flag_pic
+	      && GCC_OPTION (flag_pic)
 	      && crtl->args.info.call_cookie
 	      && reg == PIC_OFFSET_TABLE_REGNUM)
 	     || (df_regs_ever_live_p (reg)
@@ -7244,7 +7244,7 @@ calc_live_regs (HARD_REG_SET *live_regs_mask)
 	      else if (XD_REGISTER_P (reg))
 		{
 		  /* Must switch to double mode to access these registers.  */
-		  target_flags &= ~MASK_FPU_SINGLE;
+		  GCC_OPTION (target_flags) &= ~MASK_FPU_SINGLE;
 		}
 	    }
 	}
@@ -7254,7 +7254,7 @@ calc_live_regs (HARD_REG_SET *live_regs_mask)
   /* If we have a target register optimization pass after prologue / epilogue
      threading, we need to assume all target registers will be live even if
      they aren't now.  */
-  if (flag_branch_target_load_optimize2
+  if (GCC_OPTION (flag_branch_target_load_optimize2)
       && TARGET_SAVE_ALL_TARGET_REGS
       && shmedia_space_reserved_for_target_registers)
     for (reg = LAST_TARGET_REG; reg >= FIRST_TARGET_REG; reg--)
@@ -7315,7 +7315,7 @@ sh_media_register_for_return (void)
   if (sh_cfun_interrupt_handler_p ())
     return -1;
 
-  tr0_used = flag_pic && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM);
+  tr0_used = GCC_OPTION (flag_pic) && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM);
 
   for (regno = FIRST_TARGET_REG + tr0_used; regno <= LAST_TARGET_REG; regno++)
     if (call_really_used_regs[regno] && ! df_regs_ever_live_p (regno))
@@ -7454,7 +7454,7 @@ sh_expand_prologue (void)
   HARD_REG_SET live_regs_mask;
   int d, i;
   int d_rounding = 0;
-  int save_flags = target_flags;
+  int save_flags = GCC_OPTION (target_flags);
   int pretend_args;
   int stack_usage;
   tree sp_switch_attr
@@ -7475,7 +7475,7 @@ sh_expand_prologue (void)
 		       stack_pointer_rtx, 0, NULL, true);
   stack_usage = pretend_args + crtl->args.info.stack_regs * 8;
 
-  if (TARGET_SHCOMPACT && flag_pic && crtl->args.info.call_cookie)
+  if (TARGET_SHCOMPACT && GCC_OPTION (flag_pic) && crtl->args.info.call_cookie)
     /* We're going to use the PIC register to load the address of the
        incoming-argument decoder and/or of the return trampoline from
        the GOT, so make sure the PIC register is preserved and
@@ -7557,7 +7557,7 @@ sh_expand_prologue (void)
   d = calc_live_regs (&live_regs_mask);
   /* ??? Maybe we could save some switching if we can move a mode switch
      that already happens to be at the function start into the prologue.  */
-  if (target_flags != save_flags && ! current_function_interrupt)
+  if (GCC_OPTION (target_flags) != save_flags && ! current_function_interrupt)
     emit_insn (gen_toggle_sz ());
 
   if (TARGET_SH5)
